import _typeof from "@babel/runtime/helpers/typeof";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["label", "bsStyle", "children", "disabled", "buttonType"],
    _excluded2 = ["children"],
    _excluded3 = ["children"],
    _excluded4 = ["children"],
    _excluded5 = ["title", "description"];
import React from 'react';
import PropTypes from 'prop-types';
import FormTemplate from '@data-driven-forms/common/form-template';
import { Button as PF4Button } from "@patternfly/react-core/dist/dynamic/components/Button";
import { ActionGroup } from "@patternfly/react-core/dist/dynamic/components/Form";
import { Form } from "@patternfly/react-core/dist/dynamic/components/Form";
import { TextContent } from "@patternfly/react-core/dist/dynamic/components/Text";
import { Text } from "@patternfly/react-core/dist/dynamic/components/Text";
import { TextVariants } from "@patternfly/react-core/dist/dynamic/components/Text";
import { Alert } from "@patternfly/react-core/dist/dynamic/components/Alert";
export var Button = function Button(_ref) {
  var label = _ref.label,
      bsStyle = _ref.bsStyle,
      children = _ref.children,
      disabled = _ref.disabled,
      buttonType = _ref.buttonType,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(PF4Button, _extends({
    variant: buttonType === 'cancel' ? 'link' : bsStyle || 'secondary',
    isDisabled: disabled
  }, props), label, children);
};
Button.propTypes = {
  label: PropTypes.node.isRequired,
  bsStyle: PropTypes.string,
  disabled: PropTypes.bool,
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node]),
  buttonType: PropTypes.string
};
export var ButtonGroup = function ButtonGroup(_ref2) {
  var children = _ref2.children,
      props = _objectWithoutProperties(_ref2, _excluded2);

  return /*#__PURE__*/React.createElement(ActionGroup, props, children);
};
ButtonGroup.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};
export var Title = function Title(_ref3) {
  var children = _ref3.children,
      props = _objectWithoutProperties(_ref3, _excluded3);

  return /*#__PURE__*/React.createElement(TextContent, null, /*#__PURE__*/React.createElement(Text, _extends({
    component: TextVariants.h1
  }, props), children));
};
Title.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};
export var Description = function Description(_ref4) {
  var children = _ref4.children,
      props = _objectWithoutProperties(_ref4, _excluded4);

  return /*#__PURE__*/React.createElement(TextContent, null, /*#__PURE__*/React.createElement(Text, _extends({
    component: TextVariants.p
  }, props), children));
};
Description.propTypes = {
  children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};
export var FormError = function FormError(_ref5) {
  var formError = _ref5.formError,
      alertProps = _ref5.alertProps;

  if (_typeof(formError) === 'object' && formError.title) {
    var title = formError.title,
        description = formError.description,
        props = _objectWithoutProperties(formError, _excluded5);

    return /*#__PURE__*/React.createElement(Alert, _extends({
      variant: "danger",
      isInline: true,
      title: title
    }, props, alertProps), description);
  }

  if (typeof formError === 'string') {
    return /*#__PURE__*/React.createElement(Alert, _extends({
      variant: "danger",
      isInline: true,
      title: formError
    }, alertProps));
  }

  return null;
};
FormError.propTypes = {
  formError: PropTypes.any,
  alertProps: PropTypes.object
};

var PF4FormTemplate = function PF4FormTemplate(props) {
  return /*#__PURE__*/React.createElement(FormTemplate, _extends({
    BeforeError: FormError,
    FormWrapper: Form,
    Button: Button,
    ButtonGroup: ButtonGroup,
    Title: Title,
    Description: Description
  }, props));
};

export default PF4FormTemplate;