"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _Form = require("@patternfly/react-core/dist/dynamic/components/Form");

var _Text = require("@patternfly/react-core/dist/dynamic/components/Text");

var _HelperText = require("@patternfly/react-core/dist/dynamic/components/HelperText");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _showError2 = _interopRequireDefault(require("../show-error/show-error"));

var FormGroup = function FormGroup(_ref) {
  var label = _ref.label,
      isRequired = _ref.isRequired,
      helperText = _ref.helperText,
      meta = _ref.meta,
      validateOnMount = _ref.validateOnMount,
      description = _ref.description,
      hideLabel = _ref.hideLabel,
      children = _ref.children,
      id = _ref.id,
      FormGroupProps = _ref.FormGroupProps;

  var _showError = (0, _showError2["default"])(meta, validateOnMount),
      validated = _showError.validated;

  var validationInternal = (meta.touched || validateOnMount) && (meta.error || meta.submitError || meta.warning);
  return /*#__PURE__*/_react["default"].createElement(_Form.FormGroup, (0, _extends2["default"])({
    isRequired: isRequired,
    label: !hideLabel && label,
    fieldId: id,
    "aria-label": meta.error || meta.submitError
  }, FormGroupProps), description && /*#__PURE__*/_react["default"].createElement(_Text.TextContent, null, /*#__PURE__*/_react["default"].createElement(_Text.Text, {
    component: "small"
  }, description)), children, (helperText || ['error', 'warning'].includes(validated)) && /*#__PURE__*/_react["default"].createElement(_Form.FormHelperText, null, /*#__PURE__*/_react["default"].createElement(_HelperText.HelperText, null, /*#__PURE__*/_react["default"].createElement(_HelperText.HelperTextItem, {
    variant: validated
  }, validationInternal || helperText))));
};

FormGroup.propTypes = {
  label: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  meta: _propTypes["default"].object.isRequired,
  description: _propTypes["default"].node,
  hideLabel: _propTypes["default"].bool,
  validateOnMount: _propTypes["default"].bool,
  id: _propTypes["default"].string.isRequired,
  children: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].arrayOf(_propTypes["default"].element)]).isRequired,
  FormGroupProps: _propTypes["default"].object
};
var _default = FormGroup;
exports["default"] = _default;