"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Text = require("@patternfly/react-core/dist/dynamic/components/Text");

var _validTextFields = _interopRequireDefault(require("@data-driven-forms/common/utils/valid-text-fields"));

var _excluded = ["component", "label", "name", "variant", "TextContentProps"];

var PlainText = function PlainText(_ref) {
  var component = _ref.component,
      label = _ref.label,
      name = _ref.name,
      _ref$variant = _ref.variant,
      variant = _ref$variant === void 0 ? 'p' : _ref$variant,
      TextContentProps = _ref.TextContentProps,
      rest = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_Text.TextContent, TextContentProps, typeof label === 'string' ? label.split('\n').map(function (paragraph, index) {
    return /*#__PURE__*/_react["default"].createElement(_Text.Text, (0, _extends2["default"])({
      component: variant
    }, rest, {
      key: "".concat(name, "-").concat(index)
    }), paragraph);
  }) : label);
};

PlainText.propTypes = {
  variant: _propTypes["default"].oneOf(_validTextFields["default"]),
  label: _propTypes["default"].node.isRequired,
  name: _propTypes["default"].string.isRequired,
  TextContentProps: _propTypes["default"].object,
  component: _propTypes["default"].string
};
var _default = PlainText;
exports["default"] = _default;