"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _input = _interopRequireDefault(require("./input"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ValueContainer = function ValueContainer(_ref) {
  var value = _ref.value,
      isMulti = _ref.isMulti,
      placeholder = _ref.placeholder,
      getInputProps = _ref.getInputProps,
      isSearchable = _ref.isSearchable,
      inputRef = _ref.inputRef;

  if (isMulti && isSearchable) {
    return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, value, /*#__PURE__*/_react["default"].createElement(_input["default"], {
      placeholder: placeholder,
      inputRef: inputRef,
      getInputProps: getInputProps
    }));
  }

  if (!isMulti && isSearchable) {
    return /*#__PURE__*/_react["default"].createElement(_input["default"], {
      placeholder: placeholder,
      inputRef: inputRef,
      getInputProps: getInputProps,
      value: value
    });
  }

  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "pf-v5-c-select__toggle-text"
  }, value || placeholder);
};

ValueContainer.propTypes = {
  value: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isMulti: _propTypes["default"].bool,
  getInputProps: _propTypes["default"].func.isRequired,
  isSearchable: _propTypes["default"].bool,
  inputRef: _propTypes["default"].object
};
var _default = ValueContainer;
exports["default"] = _default;