"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Switch = require("@patternfly/react-core/dist/dynamic/components/Switch");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _formGroup = _interopRequireDefault(require("../form-group/form-group"));

var _isRequired = _interopRequireDefault(require("../is-required/is-required"));

var _excluded = ["label", "offText", "onText", "isRequired", "helperText", "meta", "validateOnMount", "description", "input", "isReadOnly", "isDisabled", "id", "FormGroupProps"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var Switch = function Switch(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
    type: 'checkbox'
  })),
      label = _useFieldApi.label,
      offText = _useFieldApi.offText,
      onText = _useFieldApi.onText,
      isRequired = _useFieldApi.isRequired,
      helperText = _useFieldApi.helperText,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      description = _useFieldApi.description,
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      id = _useFieldApi.id,
      FormGroupProps = _useFieldApi.FormGroupProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);

  return /*#__PURE__*/_react["default"].createElement(_formGroup["default"], {
    isRequired: isRequired,
    helperText: helperText,
    meta: meta,
    validateOnMount: validateOnMount,
    description: description,
    hideLabel: true,
    id: id || input.name,
    FormGroupProps: FormGroupProps
  }, /*#__PURE__*/_react["default"].createElement(_Switch.Switch, (0, _extends2["default"])({}, rest, input, {
    id: id || input.name,
    isDisabled: isDisabled || isReadOnly,
    label: isRequired ? /*#__PURE__*/_react["default"].createElement(_isRequired["default"], null, onText || label) : onText || label,
    labelOff: isRequired ? /*#__PURE__*/_react["default"].createElement(_isRequired["default"], null, offText || label) : offText || label
  })));
};

Switch.propTypes = {
  label: _propTypes["default"].node,
  validateOnMount: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  helperText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  isDisabled: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  onText: _propTypes["default"].node,
  offText: _propTypes["default"].node,
  FormGroupProps: _propTypes["default"].object
};
var _default = Switch;
exports["default"] = _default;