"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFormApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _Tabs = require("@patternfly/react-core/dist/dynamic/components/Tabs");

var _excluded = ["fields", "dataType", "validate", "component"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var FormTabs = function FormTabs(_ref) {
  var fields = _ref.fields,
      dataType = _ref.dataType,
      validate = _ref.validate,
      component = _ref.component,
      rest = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var formOptions = (0, _useFormApi["default"])();

  var _useState = (0, _react.useState)(0),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      activeTabKey = _useState2[0],
      setActiveTabKey = _useState2[1];

  var handleTabClick = function handleTabClick(event, tabIndex) {
    event.preventDefault();
    setActiveTabKey(tabIndex);
  };

  var renderTabItems = function renderTabItems(fields) {
    return fields.map(function (_ref2, index) {
      var fields = _ref2.fields,
          title = _ref2.title,
          name = _ref2.name;
      return /*#__PURE__*/_react["default"].createElement(_Tabs.Tab, {
        key: name,
        eventKey: index,
        title: typeof title === 'string' ? /*#__PURE__*/_react["default"].createElement(_Tabs.TabTitleText, null, title) : title
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "pf-c-form"
      }, formOptions.renderForm(fields, formOptions)));
    });
  };

  return /*#__PURE__*/_react["default"].createElement(_Tabs.Tabs, (0, _extends2["default"])({
    activeKey: activeTabKey,
    onSelect: handleTabClick
  }, rest), renderTabItems(fields, formOptions));
};

FormTabs.propTypes = {
  fields: _propTypes["default"].array.isRequired,
  dataType: _propTypes["default"].any,
  validate: _propTypes["default"].any,
  component: _propTypes["default"].any
};
var _default = FormTabs;
exports["default"] = _default;